#include "kcManViewer.h"

#include <qvariant.h>
#include <qtextbrowser.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "kcManViewer.h"
#include <stdlib.h>
#include <qfile.h>
#include <qapp.h>
#include <qregexp.h>
/* 
 *  Constructs a kcManViewer which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f'.
 */
kcManViewer::kcManViewer( QString filename, QWidget* parent,  const char* name, WFlags fl )
    : QWidget( parent, name, fl ), input(filename)
{
    resize( 861, 759 );
    setCaption( trUtf8( "KCommander Man Page View : ") + input  );

    textWindow = new QTextBrowser( this, "textWindow" );

/*
  1) wenn man.gz dann zcat
  2) wenn bz2 dan bzcat
*/
  QString command;
  QString org = input;

  if(input.right(3)==".gz")
    command = "/usr/bin/zcat";
  if(input.right(3)==".bz2")
    command = "/usr/bin/bzcat";
  input = org.left(input.findRev("."));
  input = "/tmp/" + input.right(input.length()-input.findRev("/")-1);

  if(command == "")
    system("cp " + org + " /tmp/");
  else
    system(command + " " + org + " >" + input);

  debug(input);
  QFile f(input);
  if(f.open(IO_ReadOnly))
  {
    // Hauptschleiffe
    QString line;
    while(!f.atEnd())
    {
//      debug("lese");
      f.readLine(line,255);
      // Text browsen
      while(line.length() >0)
      {
//        if(line.find("\\fI") >= -1)
//          debug("********************");
//        line = line.replace(QRegExp(" "),"FUCK");     // italic
// diese scheisse geht nicht, also selber fummeln
//        line = line.replace(QRegExp("\fI"),"<i>");     // italic
//        line = line.replace(QRegExp("\fB"),"<b>");     // bold
//        line = line.replace(QRegExp("\fR"),"</b><i>"); // font reset
        while(line.find("\\fI") >= 0)
          line = line.replace(line.find("\\fI"),3, "<i>");
        while(line.find("\\fB") >= 0)
          line = line.replace(line.find("\\fB"),3, "<b>");
        while(line.find("\\fR") >= 0)
          line = line.replace(line.find("\\fR"),3, "</b></i>");
        while(line.find("\\-") >= 0)
          line = line.replace(line.find("\\-"),2, "-");

//**************************************************************************************
        if(line.left(1) == ".")
        {
          textWindow->append("<br>");
          command = getCommand(line);
          line = line.right(line.length() - command.length()-1);
          // einige Sachen austauschen
          // hier folgt ein Befehl
          if(command == ".\\\"")
          {
            debug("REM Zeile!!");
            line = "";
          }
          if(command == ".TH")
          {
            debug("TitelZeile");
            textWindow->append(line);
            line = "";
          }
          if(command == ".SH")
          {
            textWindow->append("<b>" + line + "</b>");
            line = "";
          }
          if(command == ".B")
          {
            textWindow->append("      <b>" + line + "</b>");
            line = "";
          }
          line = "";
        }
//**************************************************************************************
        else
        {
          textWindow->append("      ");
          textWindow->append(line);
//          debug("Kein Commando");
          line = "";
        }
        qApp->processEvents();
//        debug("gelesen " + line);
//        debug("lese");
      } // Ende Zeile
    } // Ende lesen
    f.close();
    debug("MAN ready");
    // f lschen!!
  }
}

/*  
 *  Destroys the object and frees any allocated resources
 */
kcManViewer::~kcManViewer()
{
    // no need to delete child widgets, Qt does it all for us
}

void kcManViewer::resizeEvent(QResizeEvent *e)
{
  textWindow->setGeometry( 5, 5, width()-10, height()-10 );
}
QString kcManViewer::getCommand(QString zeile)
{
  // filtert commando aus der zeile
  return zeile.left(zeile.find(" "));
}

