/***************************************************************************
                          kcedit.h  -  description
                             -------------------
    begin                : Sun Jan 6 2002
    copyright            : (C) 2002 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/


#ifndef KCEDIT_H
#define KCEDIT_H

#include <qstring.h>
#include <qlayout.h>
#include <qstatusbar.h>
#include "kctextedit.h"
#include "kcimageviewer.h"
#include "hexviewedit.h"
#include "statuslineentry.h"

/**
  *@author Christian Fricke & Ren Mrten
  */

class kcEdit  : QObject
{
  Q_OBJECT
public: 
	kcEdit(QString, int type = 0);
	~kcEdit();

  QStatusBar    *statusbar;
  // Verschiedene Items fr Statusline
  statusLineEntry *stat_fsize,
                  *stat_filepos;
private:
    kcTextEdit *te1;
    hexViewEdit *hex;
    QWidget *wdg;

private slots:
  void          setInfo1(QString s);
  void          setInfo2(QString s);
  void          closeHexEdit();

};

#endif
