/****************************************************************************
** Form implementation generated from reading ui file '/home/cfricke/kcfiledialog.ui'
**
** Created: Mit Dez 12 18:34:39 2001
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "kcfiledialog.h"

/* 
 *  Constructs a kcFileDialog which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f'.
 */
kcFileDialog::kcFileDialog( QWidget* parent,  const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
  	setName( "kcFileDialog" );
    kcFileDialogLayout = new QVBoxLayout( this, 0, 1, "kcFileDialogLayout");

    buttonBar = new kcDriveButtonBar( this );
    kcFileDialogLayout->addWidget( buttonBar );
    connect(buttonBar, SIGNAL(driveChanged(QString)), SLOT(setDir(QString)));

    Layout1 = new QHBoxLayout( 0, 3, 1, "Layout1");

    bmCombo = new bookmarkComboBox( "Bookmarkentry",this );
    bmCombo->setMaximumSize( QSize( 130, 25 ) );
    bmCombo->setFocusPolicy(NoFocus);
    Layout1->addWidget( bmCombo );
    connect(bmCombo,SIGNAL(activated(const QString &)),this,SLOT(setDirFromBookmark(const QString &))) ;

    BookmarkButton = new kcSimpleButton( this, "BookmarkButton" );
    BookmarkButton->setMaximumSize( QSize( 25, 25 ) );
    BookmarkButton->setText( trUtf8( "B" ) );
    BookmarkButton->setFocusPolicy(NoFocus);
    connect(BookmarkButton,SIGNAL(clicked()),this,SLOT(BookmarkButtonPressed()));
    QToolTip::add(BookmarkButton,"Add the current directory to the bookmarks");
    Layout1->addWidget( BookmarkButton );

    PathButton = new kcSimpleButton( this, "PathButton" );
    PathButton->setMaximumSize( QSize( 32767, 25 ) );
    PathButton->setFocusPolicy(NoFocus);
    connect(PathButton,SIGNAL(clicked()),this,SLOT(PathButtonPressed()));

    QToolTip::add(PathButton,"left click activates this view\nright click show you the history of dirs");
    Layout1->addWidget( PathButton );
    kcFileDialogLayout->addLayout( Layout1 );

    IconView = new kcIconView(this,QString(name));
    ListView = new kcListView( this, QString(name));

    connect(ListView, SIGNAL(pathButtonTextChanged(QString)),       SLOT(pathButtonTextChanged(QString)));
    connect(ListView, SIGNAL(focusOut()),                           SLOT(slotListViewLostFocus()));
    connect(ListView, SIGNAL(focusIn()),                            SLOT(slotListViewGotFocus()));
    connect(ListView, SIGNAL(selectionChanged()),                   SLOT(updateSelection()));
    connect(ListView, SIGNAL(changeViewer(QString)),                SLOT(switchView(QString)));
    connect(ListView, SIGNAL(changePropertiesForFile(QFileInfo)),   SLOT(changePropertiesForFile(QFileInfo)));
    connect(ListView, SIGNAL(makeSymlinkToFile(QFileInfo)),         SLOT(makeSymlinkToFile(QFileInfo)));

    connect(IconView, SIGNAL(pathButtonTextChanged(QString)), this, SLOT(pathButtonTextChanged(QString)));
    connect(IconView, SIGNAL(focusOut()),                           SLOT(slotListViewLostFocus()));
    connect(IconView, SIGNAL(focusIn()),                            SLOT(slotListViewGotFocus()));
    connect(IconView, SIGNAL(selectionChanged()),                   SLOT(updateSelection()));
    connect(IconView, SIGNAL(changeViewer(QString)),                SLOT(switchView(QString)));
    connect(IconView, SIGNAL(changePropertiesForFile(QFileInfo)),   SLOT(changePropertiesForFile(QFileInfo)));
    connect(IconView, SIGNAL(makeSymlinkToFile(QFileInfo)),         SLOT(makeSymlinkToFile(QFileInfo)));

    QSettings settings;
    QString type;
    QString Name(IconView->name()) ;
    int c = QString::compare(Name, "ListView1" );   // c == 0
    if( !c)
    {
      type = settings.readEntry(QString("/KCommander/DialogType1"),"ListView");
    }
    else
    {
      type = settings.readEntry(QString("/KCommander/DialogType2"),"ListView");
    }
    if(type == "ListView")
    {
      IconView->hide();
      if((QString)name == "ListView1") settings.writeEntry(QString("/KCommander/DialogType1"), "ListView");
      else settings.writeEntry(QString("/KCommander/DialogType2"), "ListView");
      }
    else
    {
      ListView->hide();
      if((QString)name == "ListView1") settings.writeEntry(QString("/KCommander/DialogType1"), "IconView");
      else settings.writeEntry(QString("/KCommander/DialogType2"), "IconView");
      }

    kcFileDialogLayout->addWidget( ListView );
    kcFileDialogLayout->addWidget( IconView );

    Layout2 = new QHBoxLayout();
    selectionInfoLabel = new QLabel( this, "fileCount" );
    Layout2->addWidget(selectionInfoLabel);

    kcFileDialogLayout->addLayout( Layout2 );
}
void kcFileDialog::setDir(QString dir)
{
    directory = dir;
    if(ListView->isVisible())
    {
      ListView->clear();
      ListView->setDir(dir);
    }
    else
    {
      IconView->clear();
      IconView->setDir(dir);

    }
    updateSelection();
}

void kcFileDialog::reRead()
{
  if(ListView->isVisible())
  {
    ListView->clear();
    ListView->reRead();
  }
  else
  {
    IconView->clear();
    IconView->reRead();
  }
  updateSelection();
}

kcFileDialog::~kcFileDialog()
{
}

void kcFileDialog::pathButtonTextChanged(QString pt)
{
  PathButton->setText(pt);
  updateSelection();
}

void kcFileDialog::PathButtonPressed()
{
  emit pathButtonPressed();
}

void kcFileDialog::slotListViewGotFocus()
{
  PathButton->setActiveFlag(true);
  emit pathButtonPressed();
}
void kcFileDialog::slotListViewLostFocus()
{
  PathButton->setActiveFlag(false);
}
void kcFileDialog::updateSelection()
{
  QString s;

  int files = 0;
  int dirs = 0;
  double bytes = 0;

  bool anySelected = false; // wenn keines selektiert ist, dann geben wir info zu dem file aus...
  //
  if(ListView->isVisible())
  {
    QListViewItemIterator it(ListView);
    kcListViewItem *ki;
    for ( ; it.current(); ++it )
    {
        ki = (kcListViewItem *)it.current();
        if ( ki->isSelected() )
        {
          anySelected = true;
          if(ki->isDir())
          {
            dirs++;
            // Wenn mittels SPACE die Directorygrsse bestimmt wurde,
            // diese auch hier mit auffhren
            if(ki->text(1) != "Directory")
              bytes += ki->text(1).toFloat();
          }
          else
          {
            files++;
            bytes += ki->fileSize();
          }
        }
    }
  }
  else
  {
    QIconViewItem *it = IconView->firstItem();
    kcIconViewItem * ki;

    while(it)
    {
        ki = (kcIconViewItem *)it;
        if ( ki->isSelected() )
        {
          anySelected = true;
          if( ki->isDir())
          {
            dirs++;
          }
          else
          {
            files++;
            bytes += ki->fileSize();
          }
        }
        it = it->nextItem();
    }
  }

  if(anySelected)
  {
    // Hier in Human Readable umwandeln
    QString ext = " Bytes";
    double tempBytes = bytes;
    // grsser als 1 MB?
    if(tempBytes > 1048567)
    {
      tempBytes = tempBytes / 1024 / 1024;
      ext = tr(" MB");
      bytes = tempBytes; // Muss jetzt
      if(tempBytes > 1024)
      {
        ext = tr(" GB");
        bytes = tempBytes;
      }
    }

    QString t;
    if(ext == " GB")
    {
      if(bytes > 1000)
      {
        t.sprintf("%.2f",bytes/1000);
        ; // Punkt einfgen
      }
      else
      {
        t.sprintf("%f",bytes);
        t = t.left(t.find('.'));
      }
    }
    else
    {
      t.sprintf("%f",bytes);
      t = t.left(t.find('.'));
    }
    s.sprintf( t + ext + " selected (%d Files/%d Dirs)", files, dirs);
  }
  else
  {
    // es ist kein File angewhlt, also Info zum File
    if(ListView->isVisible())
    {
      kcListViewItem *i = (kcListViewItem *)ListView->currentItem();
      if(i)
        if(i->isSymLink())
        {
          s = "  --> " + QFileInfo(i->fullPath()).readLink();
        }
        else
        {
          s = "  " + i->text(0);
        }
    }
    else if(IconView->isVisible())
    {
      kcIconViewItem *i = (kcIconViewItem *)IconView->currentItem();
      if(i)
        if(i->isSymLink())
        {
          s = "  --> " + QFileInfo(i->fullPath()).readLink();
        }
        else
        {
          s = "  " + i->text();
        }
    }
  }
  selectionInfoLabel->setText(s);
}

void kcFileDialog::keyPressEvent(QKeyEvent *ke)
{
}
void kcFileDialog::keyReleaseEvent(QKeyEvent *ke)
{
  // wenn ALT + ENTER
  // dann an kcCommander3View emitten
  if(ke->key() == Qt::Key_Return)
    if(ke->state() == Qt::AltButton)
      emit itemRequested();
}
void kcFileDialog::cursorRequested(QKeyEvent *e)
{
  debug("Tote Routine??");
}

void  kcFileDialog::BookmarkButtonPressed()
{
  QString actualPath = PathButton->text;
//Duplettenpruefung zuerst ! (erfordert jedoch, das beide comboboxen den selben content haben am ende)
  for(int i = 0; i< bmCombo->count();i++)
  {
     if(bmCombo->text(i) == actualPath) return;
  }
  bmCombo->insertItem(PathButton->text);
  emit bookmarksChanged();
}

void  kcFileDialog::setDirFromBookmark(const QString &dir)
{
  setDir(dir);
}

void kcFileDialog::switchView(QString)
{
  QSettings settings;
  if(ListView->isVisible())
  {
    ListView->hide();
    IconView->show();
    IconView->setActiveWindow();
    IconView->setDir(ListView->dirname());
    IconView->setFocus();
      if(  (QString)IconView->name() == "ListView1")
        settings.writeEntry(QString("/KCommander/DialogType1"), "IconView");
      else
        settings.writeEntry(QString("/KCommander/DialogType2"), "IconView");
  }
  else
  {
    IconView->hide();
    ListView->show();
    ListView->setActiveWindow();
    ListView->setDir(IconView->dirname());
    ListView->setFocus();
      if( (QString)ListView->name() == "ListView1")
        settings.writeEntry(QString("/KCommander/DialogType1"), "ListView");
      else
        settings.writeEntry(QString("/KCommander/DialogType2"), "ListView");
  }

}

void  kcFileDialog::changePropertiesForFile(QFileInfo inf)
{
    dlgProperties *prop = new dlgProperties(inf, this);
    prop->exec();
    if(prop->someThingChanged)
      reRead();
}

kcListView* kcFileDialog::listView()
{
  return ListView;
}

kcView* kcFileDialog::listViewV()
{
  if(ListView->isVisible())
  return ListView;

  return IconView;
}

void kcFileDialog::makeSymlinkToFile(QFileInfo inf)
{
  debug("make Symlink");
  dlgSymlink *sym = new dlgSymlink();
  sym->LineEdit_Real->setText(inf.filePath());
  sym->LineEdit_Symlink->setFocus();
  sym->exec();
  QString real,symlink;
  real = sym->LineEdit_Real->text();
  symlink = sym->LineEdit_Symlink->text();
  if(symlink.left(1) != "/") symlink = inf.dirPath()+ QString("/") + symlink;

  QProcess *proc;
   proc = new QProcess();
   proc->addArgument(QString( "ln" ));
   proc->addArgument(QString("-s"));
   proc->addArgument(real);
   proc->addArgument(symlink);
//        connect( proc, SIGNAL(readyReadStdout()), this, SLOT(readFromStdout()) );
   if ( !proc->start() )
   {
       // error handling
   }
   while(proc->isRunning()){};
  reRead();
}