/****************************************************************************
** $Id: kcmailus.h,v 1.4 2002/04/21 16:51:01 cfricke Exp $
**
** Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/

#ifndef COMPOSER_H
#define COMPOSER_H

#include <qwidget.h>
#include <qfileinfo.h>
#include "kcsimplebutton.h"

class QLineEdit;
class QMultiLineEdit;
class QLabel;
class QPushButton;


/**
  *@author Christian Fricke & Ren Mrten
  */

class mailComposer : public QWidget
{
    Q_OBJECT

public:
    mailComposer( QWidget *parent = 0 );      // Textmail
    mailComposer( QFileInfo, QWidget *parent = 0);   // FileMail
    QLineEdit *from, *to,*to1, *subject;

private slots:
    void sendMessage();
    void sendFileMessage();
    void enableSend();
    void slotClose(){this->close();};
    void slotReadySent(const QString &);

private:
    QMultiLineEdit *message;
    QLabel * sendStatus;
    QPushButton * send, *quit;
    QFileInfo finfo;
};


#endif
