/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Die Dez 11 15:29:21 CET 2001
    copyright            : (C) 2001 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/


#include <qapplication.h>
#include <qfont.h>
#include <qstring.h>
#include <qtextcodec.h>
#include <qtranslator.h>
#include <qsettings.h>
#include <qmessagebox.h>

#include "kcommander3.h"
#include "normal.kcommander2.xpm"
#include "kcsplash.h"
#include <qmultilineedit.h>
#include "kcManViewer.h"
#include "wizzard.h"

#define RELEASE

int main(int argc, char *argv[])
{
  QApplication::setColorSpec(QApplication::ManyColor) ;

  QApplication a(argc, argv);
  a.setFont(QFont("helvetica", 12));
  QTranslator tor( 0 );
  // set the location where your .qm files are in load() below as the last parameter instead of "."
  // for development, use "/" to use the english original as
  // .qm files are stored in the base project directory.
  tor.load( QString("kcommander3.") + QTextCodec::locale(), "." );
  a.installTranslator( &tor );


//  kcSplash *splash = new kcSplash();
//  splash->exec();
  KCommander3App *kcommander3=new KCommander3App();
  a.setMainWidget(kcommander3);
  kcommander3->setIcon(QPixmap((const char **)kcpixmap));
#ifndef RELEASE

//  kcManViewer *mv = new kcManViewer("/usr/share/man/man1/cp.1.gz");
//  mv->show();
  Wizzard *w = new Wizzard(0, "Wizzard", true);
  w->show();

  QMultiLineEdit *me = new QMultiLineEdit();
  me->setText("\nChanged:\n"
              "Unsere Menus und Toolbars haben jetzt auch den MarmorHintergrund !!\n"
              "Beim langedrueck auf Buttons ohne Popup stuertzt er nich mehr ab\n"
              "\n"
              "TODO:\n"
              "0)Drag und Drop machen iss wichtig \n"
              "\n"
              "\n"
              "\n"
              "\n"
              "\n"
              "\n"
              "\n"
              "1) Shortcuts testen und ggfls einbinden\n"
              "2) Items nach Copy/Move unselekten/lschen...\n"
              "3) RENAME im copydlg einbauen\n"
              "4) Wenn Dirs/Files nicht zu lschen gehen, Dialog aufmachen\n"
              "5) Drag Drop funktionalitaet im IconView nur eingeschraenkt nutzbar Rausfinden warum !!\n"
              "6) Delete auf z.B. /usr  ist kacke Wahrscheinlich wegen Symlinks --> Machen !!\n"
              "\n"
              "\n"
              "\n"
              "\n"
              "\n"
              "\n"
              "");
  me->show();
  me->resize(600,400);
#endif
  kcommander3->show();

  return a.exec();
}


