/****************************************************************************
** Form implementation generated from reading ui file 'copydlg.ui'
**
** Created: Mit Dez 19 17:51:26 2001
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "dlgcopy.h"
#include <unistd.h>
#include "inputbox.h"

#define SKIP            4
#define SKIPALL         5
#define OVERWRITE       1
#define OVERWRITEALL    2
#define OVERWRITEOLDER  3

dlgCopy::dlgCopy( bool copy,
                  kcView *from, kcView *to, QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, true, fl ), source(from), dest(to), copyflag(copy)
{
//  	setIcon();
  	setName( "dlgCopy" );
    resize( 509, 269 );
    option = 0;
    if(copy)
      setCaption( trUtf8( "Copying Files" ) );
    else
      setCaption( trUtf8( "Moving Files" ) );

    setSizeGripEnabled( TRUE );

    dlgCopyLayout = new QVBoxLayout( this, 6, 3, "dlgCopyLayout");

    actionLabel = new QLabel( this, "actionLabel" );
    actionLabel->setText( trUtf8( "Collecting Informations" ) );
    actionLabel->setMaximumHeight(26);
    dlgCopyLayout->addWidget(actionLabel);

    TextLabel5 = new QLabel( this, "TextLabel5" );
    TextLabel5->setText( trUtf8( "Sourcefilename" ) );
    TextLabel5->setMaximumHeight(26);
    dlgCopyLayout->addWidget(TextLabel5);

    TextLabel6 = new QLabel( this, "TextLabel6" );
    TextLabel6->setText( trUtf8( "Destfilename" ) );
    TextLabel6->setMaximumHeight(26);
    dlgCopyLayout->addWidget(TextLabel6);

    TextLabel2 = new QLabel( this, "TextLabel2" );
    TextLabel2->setText( trUtf8( "Bytes" ) );
    TextLabel2->setMaximumHeight(26);
    dlgCopyLayout->addWidget(TextLabel2);
    ProgressBar2 = new QProgressBar( this, "ByteProgress" );
    ProgressBar2->setMaximumHeight(25);
    dlgCopyLayout->addWidget(ProgressBar2);

    TextLabel3 = new QLabel( this, "TextLabel3" );
    TextLabel3->setText( trUtf8( "Count" ) );
    TextLabel3->setMaximumHeight(26);
    dlgCopyLayout->addWidget(TextLabel3);
    ProgressBar3 = new QProgressBar( this, "CountProgress" );
    ProgressBar3->setMaximumHeight(25);
    dlgCopyLayout->addWidget(ProgressBar3);

    QWidget* privateLayoutWidget = new QWidget( this, "Layout1" );
    Layout1 = new QHBoxLayout( privateLayoutWidget, 0, 6, "Layout1");

    buttonCancel = new QPushButton( privateLayoutWidget, "buttonCancel" );
    buttonCancel->setText( trUtf8( "Cancel" ) );
    buttonCancel->setAccel( 0 );
    buttonCancel->setAutoDefault( TRUE );
    buttonCancel->setMaximumHeight(25);
    Layout1->addWidget( buttonCancel );

    dlgCopyLayout->addWidget(privateLayoutWidget);
    // signals and slots connections
    connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( cancelPressed()));
    time = new QTimer(this);
    connect(time, SIGNAL(timeout()), SLOT(started()));
    buttonCancel->setEnabled(false);
    setCursor(WaitCursor);
    breakFlag = false;
    time->start(50,true);
}

dlgCopy::~dlgCopy()
{
}
void dlgCopy::cancelPressed()
{
  breakFlag = true;
  reject();
}
void dlgCopy::started()
{
  getRecursiveList();
  buttonCancel->setEnabled(true);
  setCursor(ArrowCursor);
  QString act;
  act.sprintf(tr("%d files/%.0f bytes"),files, bytes);

  // OK, hier das Ziel abfragen
  QString destination = dest->dirname();
  QString oldDestination = destination;
  InputBox *input;

  if(copyflag)
    input = new InputBox(this,"KCommander::copy","Copy " + act + " to",destination);
  else
    input = new InputBox(this,"KCommander::move","Move " + act + " to",destination);
  switch(input->exec())
  {
    case 0:
      // Abbruch gedrckt...
      reject();
      return;
      break;
    case 1:
        destination = input->returnInput();
      break;
  }
  debug("Ziel: " + destination);
  if(destination == "")
  {
    reject();
    return;
  }

  if(copyflag)
    actionLabel->setText("Copying...");
  else
    actionLabel->setText("Moving...");

  if(destination == oldDestination)
  {
    startCopy();
  }
  else
  {
    debug("Hier fehlt das RENAME!!!");
  }

}

void dlgCopy::getRecursiveList()
{
  liste = new QStrList;
  files = dirs = 0;
  bytes = 0;
  bool  anySelected = false;

  QString directory = source->dirname();

  kcListViewItem *ki;
  kcIconViewItem *kj;

  if(dynamic_cast<kcListView*>(source))
  {
   QListViewItemIterator it((kcListView*)source);
   if(((kcListView*)source)->childCount() != 0)
   {
    for ( ; it.current(); ++it )
    {
        ki = (kcListViewItem *)it.current();
        if ( ki->isSelected() )
        {
          if(ki->isDir())
          {
            if(ki->isReadable())
              recurse(directory + ki->text(0) + "/");
          }
          else
          {
            files++;
            QFileInfo fi(directory + ki->text(0));
            if(! fi.isSymLink())
            {
              bytes += fi.size();
            }
            liste->append(directory + ki->text(0));
          }
          anySelected = true;
        }
    }
  }
  if(!anySelected)
  {
    ki = (kcListViewItem *)((kcListView*)source)->currentItem();
    if(ki->isDir())
    {
      if(ki->isReadable())
        recurse(directory + ki->text(0) + "/");
    }
    else
    {
      files++;
      QFileInfo fi(directory + ki->text(0));
      if(! fi.isSymLink())
        bytes += fi.size();
      liste->append(directory + ki->text(0));
    }
  }
  } // end if LISTVIEW
  else
  { // if ICONVIEW
    kj = (kcIconViewItem*)((kcIconView*)source)->firstItem() ;
    if(((kcIconView*)source)->count() != 0)
   {
      while (kj)
      {
          if ( kj->isSelected() )
          {
            if(kj->isDir())
            {
              if(kj->isReadable())
                recurse(directory + kj->text() + "/");
            }
            else
            {
              files++;
              QFileInfo fi(directory + kj->text());
              if(! fi.isSymLink())
              {
                bytes += fi.size();
              }
              liste->append(directory + kj->text());
            }
            anySelected = true;
          }
          kj =  (kcIconViewItem*)kj->nextItem() ;
      }
    }
    if(!anySelected)
    {
     kj = (kcIconViewItem *)((kcIconView*)source)->currentItem();
      if(kj->isDir())
      {
        if(kj->isReadable())
          recurse(directory + kj->text() + "/");
      }
      else
      {
        files++;
        QFileInfo fi(directory + kj->text());
        if(! fi.isSymLink())
          bytes += fi.size();
        liste->append(directory + kj->text());
      }
    }
  } // end if ICONVIEW
}
void dlgCopy::recurse(QString dirname)
{
  dirs++;
  qApp->processEvents();
  liste->append(dirname);
  QDir d(dirname);
  d.setFilter( QDir::Files | QDir::Dirs | QDir::Hidden);
  const QFileInfoList *list = d.entryInfoList();
  QFileInfoListIterator it( *list );
  QFileInfo *fi;
  while ( (fi = it.current()) != 0 )
  {
    if(fi->fileName() != ".." && fi->fileName() != ".")
      if(fi->isReadable())
        if(fi->isDir())
          recurse(dirname + fi->fileName() + "/");
        else
        {
          files++;
          if(! fi->isSymLink())
            bytes += fi->size();
          liste->append(dirname + fi->fileName());
        }
    ++it;
  }
}
void dlgCopy::startCopy()
{
  setCursor(Qt::WaitCursor);
//  buttonOk->setEnabled(false);
  char buffer[1000000];
  ProgressBar2->setTotalSteps(bytes);

  if(files >= 2)ProgressBar3->setTotalSteps(files);  //Wenn nur ein File dann geht diese Funktion gegen den Baum :(
  else ProgressBar3->setTotalSteps(files+1);         // Scheiss Qt ich denke wir brauchen wieder mal ne eigene Progressbar

  QString s;
  int baselen = source->dirname().length();
  QString base(source->dirname());
  QString destination(dest->dirname());
  debug("'" + dest->dirname() + "'");

  bool success = true;
  bool skip    = false;
  unsigned int written = 0;
  QStrList  dirs;

  for(unsigned int i = 0; i<liste->count(); i++)
  {
    ProgressBar3->setProgress(i);
    s = liste->at(i);
    s = s.right(s.length()-baselen);
    if(s.right(1) == "/")
    {
      QDir d(destination + s);
      if(!d.exists())
      {
        if(!d.mkdir(destination + s))
        {
          success = false;
          break;
        }
        dirs.append(base+s);
        emit dirDeleted(base, base+s );
      }
    }
    else
    {
      QFile input(base + s);
      QFileInfo fi_i(input);
      if(fi_i.isSymLink())
      {
        if(!symlink( fi_i.readLink(), destination + s))
        {
          debug("cant create symlink!");
        }
      }
      else
      {
         QFile output(destination + s);
         QFileInfo fi_o(output);
         if(option != OVERWRITEALL)
         {
           if(output.exists())
           {
              QDateTime dt_i = fi_i.lastModified();
              QDateTime dt_o = fi_o.lastModified();
              if(option != SKIPALL)
              {
                if(option != OVERWRITEOLDER)
                {
                  dlgOverwrite dlg;
                  QString ts = dt_i.toString(Qt::LocalDate) + ", %d Bytes";
                  QString td = dt_o.toString(Qt::LocalDate) + ", %d Bytes";
                  ts.sprintf(ts,fi_i.size());
                  td.sprintf(td,fi_o.size());

                  dlg.lb_fileToCopy->setText(s + "  (" + ts + ")");
                  dlg.lb_existingFile->setText(s + "  (" + td + ")");
                  dlg.exec();
                  int result = dlg.option();
                  if(!result)
                  {
                    input.close();
                    output.close();
                    reject();
                    return;
                  }
                  else switch(result)
                  {
                    case 1:       // Overwrite one file
                      option = 0; // bei 0 wird automatisch berschrieben
                      break;
                    case 2:       // Overwrite all files
                      option = OVERWRITEALL;
                      break;
                    case 3:       // Overwrite only older files
                      option = OVERWRITEOLDER;
                      break;
                    case 4:       // Skip file
                      option = SKIP;
                      skip = true;
                      break;
                    case 5:       // Skip all files
                      option = SKIPALL;
                      break;
                  }
                }
                else // Overwrite older
                  if(dt_i < dt_o)
                    skip = true;
              }
              else
                skip = true;
           }
         }
         if(!skip)
         {
           TextLabel5->setText(base+s);
           TextLabel6->setText(destination + s);
           if(!input.open(IO_ReadOnly))
           {
             success = false;
             debug("Inputfile liess sich nicht ffnen");
             debug("*** " + base + s);
             break;
           }
           if(!output.open(IO_WriteOnly))
           {
             success = false;
             input.close();
             debug("Konnte Outputfile nicht ffnen!");
             debug("*** " + destination + s);
             break;
           }
           // starting copying
           while(!input.atEnd())
           {
             qApp->processEvents(10);
             if(breakFlag)
             {
              input.close();
              output.close();
              return;
             }
             int readed = input.readBlock((char *)&buffer, 1000000);
             output.writeBlock((char *)&buffer,readed);
             written += readed;
             ProgressBar2->setProgress(written);
           }
           // Hier files lschen wenn MOVE
           if(!copyflag)
           {
              bool result = input.remove();
              if(result)
              {
//                debug(input.name() + " erfolgreich gelscht");
              }
              else
              {
//                debug("Konnte File " + input.name() + " nicht lschen...");
              }
           }
         }
         else
         {
            // bei Skip noch Progressbar weiterzhlen etc
         } // ende SKIP
         skip = false;
      }
      if(!success)
      {
//        debug("bei File %d irgendwas schief gelaufen!",i);
      }
    }
  }
  // Noch die Directorys lschen
  if(!copyflag)
    while(dirs.count())
    {
      bool result = QDir(dirs.last()).rmdir(dirs.last());
      if(result)
      {
        debug(dirs.last() + QString(" erfolgreich gelscht"));
        emit dirDeleted(base, dirs.last());
      }
      else
      {
        debug(QString("Konnte File ") + dirs.last() + " nicht lschen...");
      }
      dirs.removeLast();
    }
  if(!success)
    ;
//    debug("irgendwas schief gelaufen!");
  else
    ;
//    debug("Kopieren OHNE Fehler!");
  setCursor(Qt::ArrowCursor);
  accept();
}


// Hardcore for DND !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
dlgCopy::dlgCopy(QStrList lst ,QString to, QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, true, fl )
{
//  	setIcon();
    SourceList = lst;
    QFileInfo destInf(to);
    if(destInf.isDir())  DestString = to;
    else DestString =  destInf.dirPath();

  	setName( "dlgCopy" );
    resize( 509, 269 );
    option = 0;
      setCaption( trUtf8( "Copying Files" ) );

    setSizeGripEnabled( TRUE );

    dlgCopyLayout = new QVBoxLayout( this, 6, 3, "dlgCopyLayout");

    actionLabel = new QLabel( this, "actionLabel" );
    actionLabel->setText( trUtf8( "Collecting Informations" ) );
    actionLabel->setMaximumHeight(26);
    dlgCopyLayout->addWidget(actionLabel);

    TextLabel5 = new QLabel( this, "TextLabel5" );
    TextLabel5->setText( trUtf8( "Sourcefilename" ) );
    TextLabel5->setMaximumHeight(26);
    dlgCopyLayout->addWidget(TextLabel5);

    TextLabel6 = new QLabel( this, "TextLabel6" );
    TextLabel6->setText( trUtf8( "Destfilename" ) );
    TextLabel6->setMaximumHeight(26);
    dlgCopyLayout->addWidget(TextLabel6);

    TextLabel2 = new QLabel( this, "TextLabel2" );
    TextLabel2->setText( trUtf8( "Bytes" ) );
    TextLabel2->setMaximumHeight(26);
    dlgCopyLayout->addWidget(TextLabel2);
    ProgressBar2 = new QProgressBar( this, "ByteProgress" );
    ProgressBar2->setMaximumHeight(25);
    dlgCopyLayout->addWidget(ProgressBar2);

    TextLabel3 = new QLabel( this, "TextLabel3" );
    TextLabel3->setText( trUtf8( "Count" ) );
    TextLabel3->setMaximumHeight(26);
    dlgCopyLayout->addWidget(TextLabel3);
    ProgressBar3 = new QProgressBar( this, "CountProgress" );
    ProgressBar3->setMaximumHeight(25);
    dlgCopyLayout->addWidget(ProgressBar3);

    QWidget* privateLayoutWidget = new QWidget( this, "Layout1" );
    Layout1 = new QHBoxLayout( privateLayoutWidget, 0, 6, "Layout1");

    buttonCancel = new QPushButton( privateLayoutWidget, "buttonCancel" );
    buttonCancel->setText( trUtf8( "Cancel" ) );
    buttonCancel->setAccel( 0 );
    buttonCancel->setAutoDefault( TRUE );
    buttonCancel->setMaximumHeight(25);
    Layout1->addWidget( buttonCancel );

    dlgCopyLayout->addWidget(privateLayoutWidget);
    // signals and slots connections
    connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( cancelPressed()));
    time = new QTimer(this);
    connect(time, SIGNAL(timeout()), SLOT(startedDND()));
    buttonCancel->setEnabled(false);
    setCursor(WaitCursor);
    breakFlag = false;
    time->start(50,true);
}

void dlgCopy::startedDND()
{
  getRecursiveListDND();
  buttonCancel->setEnabled(true);
  setCursor(ArrowCursor);
  QString act;
  act.sprintf(tr("%d files/%.0f bytes"),files, bytes);

  // OK, hier das Ziel abfragen
  QString destination = DestString;
  QString oldDestination = destination;
  InputBox *input;

  input = new InputBox(this,"KCommander::copy","Copy " + act + " to",destination);
  switch(input->exec())
  {
    case 0:
      // Abbruch gedrckt...
      reject();
      return;
      break;
    case 1:
        destination = input->returnInput();
      break;
  }
  if(destination == "")
  {
    reject();
    return;
  }

    actionLabel->setText("Copying...");

  if(destination == oldDestination)
  {
    startCopyDND();
  }
  else
  {
    debug("Hier fehlt das RENAME!!!");
  }

}

void dlgCopy::getRecursiveListDND()
{
  liste = new QStrList;
  files = dirs = 0;
  bytes = 0;

   if(SourceList.count() != 0)
   {
    for (unsigned int i =0 ; i< SourceList.count(); i++ )
    {

      QString base(SourceList.at(i));
//    Wenn was vom Desktop reinkopiert wird (KDE) dann steht da immer "file:" davor !!
      if(base.find("file:") != -1) base = base.right(base.length()-5);

      QFileInfo ki(base);
          if(ki.isDir())
          {
            if(ki.isReadable())
              recurse(QString(base)+"/");
          }
          else
          {
            files++;
            if(! ki.isSymLink())
            {
              bytes += ki.size();
            }
            liste->append(SourceList.at(i));
        }
    }
  }
}

void dlgCopy::startCopyDND()
{
  setCursor(Qt::WaitCursor);
//  buttonOk->setEnabled(false);
  char buffer[1000000];
  ProgressBar2->setTotalSteps(bytes);

  if(files >= 2)ProgressBar3->setTotalSteps(files);  //Wenn nur ein File dann geht diese Funktion gegen den Baum :(
  else ProgressBar3->setTotalSteps(files+1);         // Scheiss Qt ich denke wir brauchen wieder mal ne eigene Progressbar

  QString s;
  QFileInfo sourceInf(SourceList.at(0));
//  int baselen = sourceInf.dirPath().length();
  QString base(sourceInf.dirPath());
// Wenn was vom Desktop reinkopiert wird (KDE) dann steht da immer "file:" davor !!
#warning    So wird das   file:  weggemacht :)
  QUrl test(base);
  base = test.toString(true,false);
//  if(base.find("file:") != -1) base = base.right(base.length()-5);
  int baselen = base.length()-1;

  QString destination(DestString);

  bool success = true;
  bool skip    = false;
  unsigned int written = 0;
  QStrList  dirs;

  for(unsigned int i = 0; i<liste->count(); i++)
  {
    ProgressBar3->setProgress(i);
    s = liste->at(i);
    QUrl macheRichtig(s);              // Rene hier war noch   file:    davor aber warum der aus nem OE  was anderes macht weiss ich nicht :()
    s = macheRichtig.toString(true,false);
    s = s.right(s.length()-baselen);
    if(s.right(1) == "/")
    {
      debug(destination + s);
      QDir d(destination + s);
      if(!d.exists())
      {
        if(!d.mkdir(destination + s))
        {
          success = false;
          break;
        }
        dirs.append(base+s);
        emit dirDeleted(base, base+s );
      }
    }
    else
    {
      QFile input(base + s);
      QFileInfo fi_i(input);
      if(fi_i.isSymLink())
      {
        if(!symlink( fi_i.readLink(), destination + s))
        {
          debug("cant create symlink!");
        }
      }
      else
      {
         QFile output(destination + s);
         QFileInfo fi_o(output);
         if(option != OVERWRITEALL)
         {
           if(output.exists())
           {
              QDateTime dt_i = fi_i.lastModified();
              QDateTime dt_o = fi_o.lastModified();
              if(option != SKIPALL)
              {
                if(option != OVERWRITEOLDER)
                {
                  dlgOverwrite dlg;
                  QString ts = dt_i.toString(Qt::LocalDate) + ", %d Bytes";
                  QString td = dt_o.toString(Qt::LocalDate) + ", %d Bytes";
                  ts.sprintf(ts,fi_i.size());
                  td.sprintf(td,fi_o.size());

                  dlg.lb_fileToCopy->setText(s + "  (" + ts + ")");
                  dlg.lb_existingFile->setText(s + "  (" + td + ")");
                  dlg.exec();
                  int result = dlg.option();
                  if(!result)
                  {
                    input.close();
                    output.close();
                    reject();
                    return;
                  }
                  else switch(result)
                  {
                    case 1:       // Overwrite one file
                      option = 0; // bei 0 wird automatisch berschrieben
                      break;
                    case 2:       // Overwrite all files
                      option = OVERWRITEALL;
                      break;
                    case 3:       // Overwrite only older files
                      option = OVERWRITEOLDER;
                      break;
                    case 4:       // Skip file
                      option = SKIP;
                      skip = true;
                      break;
                    case 5:       // Skip all files
                      option = SKIPALL;
                      break;
                  }
                }
                else // Overwrite older
                  if(dt_i < dt_o)
                    skip = true;
              }
              else
                skip = true;
           }
         }
         if(!skip)
         {
           TextLabel5->setText(base+s);
           TextLabel6->setText(destination + s);
           if(!input.open(IO_ReadOnly))
           {
             success = false;
             debug("Inputfile liess sich nicht ffnen");
             debug("*** " + base + s);
             debug(s);
             break;
           }
           if(!output.open(IO_WriteOnly))
           {
             success = false;
             input.close();
             debug("Konnte Outputfile nicht ffnen!");
             debug("*** " + destination + s);
             break;
           }
           // starting copying
           while(!input.atEnd())
           {
             qApp->processEvents(10);
             if(breakFlag)
             {
              input.close();
              output.close();
              return;
             }
             int readed = input.readBlock((char *)&buffer, 1000000);
             output.writeBlock((char *)&buffer,readed);
             written += readed;
             ProgressBar2->setProgress(written);
           }
           // Hier files lschen wenn MOVE
//           if(!copyflag)
//           {
//              bool result = input.remove();
//              if(result)
//              {
////                debug(input.name() + " erfolgreich gelscht");
//              }
//              else
//              {
////                debug("Konnte File " + input.name() + " nicht lschen...");
//              }
//           }
         }
         else
         {
            // bei Skip noch Progressbar weiterzhlen etc
         } // ende SKIP
         skip = false;
      }
      if(!success)
      {
//        debug("bei File %d irgendwas schief gelaufen!",i);
      }
    }
  }
  // Noch die Directorys lschen
//  if(!copyflag)
//    while(dirs.count())
//    {
//      bool result = QDir(dirs.last()).rmdir(dirs.last());
//      if(result)
//      {
//        debug(dirs.last() + QString(" erfolgreich gelscht"));
//        emit dirDeleted(base, dirs.last());
//      }
//      else
//      {
//        debug(QString("Konnte File ") + dirs.last() + " nicht lschen...");
//      }
//      dirs.removeLast();
//    }
  if(!success)
    ;
//    debug("irgendwas schief gelaufen!");
  else
    ;
//    debug("Kopieren OHNE Fehler!");
  setCursor(Qt::ArrowCursor);
  accept();
}
