/***************************************************************************
                          KTar2.cpp  -  description
                             -------------------
    begin                : Thu Oct 14 1999
    copyright            : (C) 1999 by Rene Mrten, Christian Fricke
    email                : @-Mail to: delta_x@LinuxCoding.DE
                                      cfricke@LinuxCoding.DE
****************************************************************************/
#include "dlgtar.h"
#include <qapplication.h>
#include <qtextstream.h>

KTar2::KTar2(kcView *from , const char *archivename,QWidget *parent, const char *name) : QDialog(parent,name,true)
{
//*****************************************************************************************
	// Optik !!
	source = from;
	arc = archivename;
	ende = false;
	resize(300,120);
	setMinimumSize(300,120);
	setMaximumSize(300,120);
	QLabel *l;
	l = new QLabel("Info:",this);
	l->setGeometry(10,30,50,20);
	dateiname = new QLabel(tr("File :"),this);
	dateiname->setGeometry(60,30,230,20);
	QString s;
//	Packer = optionen::askPacker();
	Packer = "tar";
	s.sprintf(QString("KTar2 ") + tr("compress with ") + Packer);
 	setCaption(s);
	p1 = new QProgressBar(100,this);
	p1->setGeometry(10,55,280,20);

	deleteSymlinks = false;
   qApp->processEvents();
   getRecursiveList();		
	startTimer(500);	
}

KTar2::~KTar2(){
}

void	KTar2::timerEvent(QTimerEvent *)
{
	killTimers();
	doIt(arc);
}

void KTar2::doIt(const char *archivename)
{
		int files = 0;				// filecounter = 0
		int percent=0;
		QString s,a;

		QDir::setCurrent(source->dirname());
		a = source->dirname();
		a += "/";
		a += archivename;
		s = liste->first();
		
		if(s.contains("..")) {receivedStderr();return;};   // Wenn das UP also (..)  angeklicked wurde dann weg hier !!
		
		files = liste->count();
	    	if(files == 1)		p1->setTotalSteps(files+1);  // Das Ding ist TOTALE Scheisse !! Wenn ich das nicht mache gibts nen Absturz
		else p1->setTotalSteps(files);
		percent = 0;
		qApp->processEvents();
		
		dateiname->setText(s);
		
		nextFile = false;			// muss warten, solange bis TAR Ergebnis zurckgibt (false or true, togal!)
		QProcess proc;
		proc.addArgument("tar");
		proc.addArgument("cf");                        // neues Archiv erstellen !
		proc.addArgument(a+".tar");	// Archivename
		proc.addArgument(s);														// Dateiname
		QApplication::connect(&proc, SIGNAL(processExited()),this, SLOT(slotExamine()));
		QApplication::connect(&proc, SIGNAL(readyReadStdout()), this, SLOT(receivedStdout()));
//		QApplication::connect(&proc, SIGNAL(readyReadStderr()), this, SLOT(receivedStderr()));
		proc.start();
		p1->setProgress(percent++);
		
		while(!nextFile)
		qApp->processEvents();	// solange in Schleife bleiben, wie nextFile = false
		// ersten Filenamen loeschen weil gepackt
		liste->removeFirst();

	  if( liste->first() ){    // Achting noch nicht abgefragt !!
	  for(unsigned int i=0 ; i < liste->count(); ++i )
    	{
			s = liste->at(i);
			qApp->processEvents();
			QString ss=s;
			if(ss.length() >30)
			{
				ss = ss.left(15) + "...." + ss.right(15);
			}
			dateiname->setText(ss);
			QProcess proc2;
			proc2.addArgument("tar");
			proc2.addArgument("rf");
			proc2.addArgument(a +".tar");	// Archivename
			proc2.addArgument(s);						// Dateiname
			
			nextFile = false;					// das er nicht gleich noch weiter macht
    		QApplication::connect(&proc2, SIGNAL(processExited()),this, SLOT(slotExamine()));
    	  	QApplication::connect(&proc2, SIGNAL(readyReadStdout()), this, SLOT(receivedStdout()));
//	    	QApplication::connect(&proc2, SIGNAL(readyReadStderr()), this, SLOT(receivedStderr()));
			proc2.start();
			while(!nextFile)
				qApp->processEvents();	// solange in Schleife bleiben, wie nextFile = false
			p1->setProgress(percent++);
			if(ende == true)	// ende wird nur TRUE, wenn Fenster whrend des Packens geschlosssen wird
			{
				return;
			}
 		}
 		}
		ende = true;
			
			p1->setProgress(p1->totalSteps());  // hier hat Qt Probleme aber das kennen wir ja schon !!

			nextFile = false;
			QProcess proc1;
			proc1.addArgument("gzip");
			proc1.addArgument(a +".tar");	// Archivename
    		QApplication::connect(&proc1, SIGNAL(processExited()),this, SLOT(slotExamine()));
	    	QApplication::connect(&proc1, SIGNAL(readyReadStdout()), this, SLOT(receivedStdout()));
	    	QApplication::connect(&proc1, SIGNAL(readyReadStderr()), this, SLOT(receivedStderr()));
			proc1.start();
			while(!nextFile) qApp->processEvents();
		
		accept();
}


void KTar2::slotExamine()
{
//	QMessageBox::critical ( (QWidget *)this, "KTar2", "prog zu Ende", 0, 0 );
	nextFile = true;
}
void KTar2::receivedStdout()
{
	ready = true;
}
void KTar2::receivedStderr()
{
	QMessageBox::critical ( (QWidget *)this, "KCompress", tr("Error while compressing"), 0, 0 );
	killTimers();
	ende = true;
	nextFile = true;
	close();
}
void KTar2::closeEvent ( QCloseEvent *e)
{
  if(!ende)
  {
		int i = QMessageBox::information ( this, tr("Cancel ?"), tr("Break This Process ?"), QMessageBox::Yes, QMessageBox::No);
		if(i == QMessageBox::Yes)
		{
			ende = true;
			e->accept();
		}
	}
	else
		e->accept();
}

void KTar2::getRecursiveList()
{
  // Diese Funktion geht alle ausgewhlten Items durch, und erstellt
  // eine QStrList mit Dirs/Files
  liste = new QStrList;
  QString directory = source->dirname();

  if(dynamic_cast<kcListView*>(source))
  {
    QListViewItemIterator it((kcListView*)source);
    kcListViewItem *ki;
    for ( ; it.current(); ++it )
    {
        ki = (kcListViewItem *)it.current();
        if ( ki->isSelected() )
          if(ki->isDir()){
            if(ki->isReadable()) //muss natuerlich auch mindestens lesbar sein hat Rene vergessen !!
            {
//                recurse(directory + ki->text(0) + "/");
                liste->append(ki->text(0));
            }
          }
          else
            {
              liste->append(ki->text(0));
            }
    }
    if(liste->count() == 0)
    {
      //kein rechts-selected !!
      ki = (kcListViewItem *)((kcListView*)source)->currentItem();
      if(ki->isDir()){
        if(ki->isReadable())
        {
          liste->append(ki->text(0) );
        }
      }
      else
      {
        liste->append(ki->text(0));
        }
    }
  }   // end if kcListView
  else
  {
    QIconViewItem *it = ((kcIconView*)source)->firstItem();
    kcIconViewItem * ki;
    do
    {
        ki = (kcIconViewItem *)it;
        if ( ki->isSelected() )
          if(ki->isDir()){
            if(ki->isReadable()) //muss natuerlich auch mindestens lesbar sein hat Rene vergessen !!
            {
                liste->append(ki->text());
            }
          }
          else
            {
              liste->append(ki->text());
            }
          it = it->nextItem();
    }
    while(it);

    if(liste->count() == 0)
    {
      //kein rechts-selected !!
      ki = (kcIconViewItem *)((kcIconView*)source)->currentItem();
      if(ki->isDir()){
        if(ki->isReadable())
        {
          liste->append(ki->text() );
        }
      }
      else
      {
        liste->append(ki->text());
        }
    }
  } // end if kcIconView
}

void KTar2::recurse(QString dirname)
{
  qApp->processEvents();
  QDir d(dirname);
  liste->append(dirname);

  if(! deleteSymlinks){
  QFileInfo inf(dirname);
  if(inf.isSymLink()) return;
  }

  d.setFilter( QDir::Files | QDir::Dirs | QDir::Hidden);
  const QFileInfoList *list = d.entryInfoList();
  QFileInfoListIterator it( *list );
  QFileInfo *fi;
  while ( (fi = it.current()) != 0 )
  {
    if(fi->fileName() != ".." && fi->fileName() != ".")
      if(fi->isReadable())
      {
       if(!deleteSymlinks) // Wenn Symbolic links nicht geloescht werden sollen
       {
        if(fi->isDir() && fi->isSymLink() == false)
        {
          recurse(dirname+ "/" + fi->fileName());
        }
        else
        {
          liste->append(dirname + "/" + fi->fileName());
        }
       }
       else // Wenn symbolic links doch geloescht werden sollen
       {
        if(fi->isDir())
        {
          recurse(dirname+ "/" + fi->fileName());
        }
        else
        {
          liste->append(dirname + "/" + fi->fileName());
        }
       }
      }
    ++it;
  }
}
