/***************************************************************************
                          inputbox.cpp  -  description
                             -------------------
    begin                : Sat Oct 9 1999
    copyright            : (C) 1999 by lcg
    email                : delta_x@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "inputbox.h"

// wenn OK dann ergebnis 1 ansonsten 0

InputBox::InputBox( QWidget *parent, const char *xCaption,const char *info, const char *Vorgabe, const char *name)
: QDialog( parent, name, TRUE )
{

	setGeometry(parent->x()+(parent->width()/2)-100, parent->y()+(parent->height()/2)-50,
					270,100);
						
	infotext = new QLabel(this);
	infotext->setText(info);
	
	ok = new kcSimpleButton(this,"Ok");
	ok->setText(tr("Ok"));
	ok->setGeometry( 10,70, 90,25 );
	connect( ok, SIGNAL(clicked()), SLOT(accept()) );
	
	cancel = new kcSimpleButton(this,"Cancel" );
	cancel->setText(tr("Cancel"));
	cancel->setGeometry( 170,70, 90,25 );
	connect( cancel, SIGNAL(clicked()), SLOT(reject()) );

	infotext->setGeometry(10,10,250,25);

	me = new QLineEdit(this);
	if(Vorgabe != 0)
	{
		me->setText(Vorgabe);
		me->selectAll();
	}
	me->setGeometry(10,40,250,25);
	setCaption(xCaption);
	me->setFocus();
	
	connect(me,SIGNAL(returnPressed()),SLOT(accept()));
}

InputBox::~InputBox()
{
	delete cancel;
	delete ok;
	delete me;
	
}

QString InputBox::returnInput()
{
	return me->text();
}
