/***************************************************************************
                          kccommandparse.cpp  -  description
                             -------------------
    begin                : Mon Dec 31 2001
    copyright            : (C) 2001 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/

#include <stdlib.h>
#include "kccommandparse.h"

kcCommandParse::kcCommandParse(){
}
kcCommandParse::~kcCommandParse(){
}

void kcCommandParse::doCommand(kcListView* activeListDialog,kcListView* passiveListDialog,QString s)
{

  if(s.left(1) == "/")
#warning   Was ist wenn einer einen Befehl aus einem Dir ausfuehrt ??
  {
    activeListDialog->setDir(s);
    return;
  }
  if(s == "cd")
  {
    // cd HOME
    activeListDialog->setDir(QDir::homeDirPath());
  }
  else if(s.left(3) == "cd ")
  {
    activeListDialog->setDir(s.right(s.length()-s.find(" ")-1)) ;
    return;
  }

  // cp und mv und rm sollten wir machen, damit wir alles mitbekommen
  // Alles was ab hier kommt sollte das system uebernehmen !
   int err = system(s);
   if ( err >= 32000 || err == -1)
   {
        QString errString( "unknown command: " + s);
       	QMessageBox::critical ( activeListDialog, "KCommand",errString, 0, 0 );
   }
}

