/****************************************************************************
** Form interface generated from reading ui file '/home/cfricke/kcfiledialog.ui'
**
** Created: Mit Dez 12 18:34:34 2001
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#ifndef KCFILEDIALOG_H
#define KCFILEDIALOG_H

#include <qvariant.h>
#include <qwidget.h>

#include <qvariant.h>   // first for gcc 2.7.2
#include <qheader.h>
#include <qlabel.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qsettings.h>

#include "kclistview.h"
#include "kciconview.h"
#include "kcview.h"
#include "kcsimplebutton.h"
#include "kcdrivebuttonbar.h"
#include "bookmarkcombobox.h"
#include "dlgproperties.h"
#include "dlgsymlink.h"

/**
  *@author Christian Fricke & Ren Mrten
  */

class kcFileDialog : public QWidget
{ 
    Q_OBJECT

public:
    kcFileDialog( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~kcFileDialog();

    kcListView        *listView();
    kcView            *listViewV();
    kcListView        *listViewList(){return ListView;};
    kcIconView       *listViewIcon(){return IconView;};
    bookmarkComboBox* getBmCombo(){return bmCombo;};
    QString             currentDir(){return directory;} ;
    void reRead();

private:
    bookmarkComboBox  *bmCombo;
   	kcSimpleButton    *BookmarkButton;
	  kcSimpleButton    *PathButton;
    kcListView        *ListView;
    kcIconView        *IconView;
    kcView            *ItemView;
    QLabel            *selectionInfoLabel;
    kcDriveButtonBar  *buttonBar;
    QString           directory;

protected:
    QVBoxLayout       *kcFileDialogLayout;
    QHBoxLayout       *Layout1;
    QHBoxLayout       *Layout2;

private slots:
    void              pathButtonTextChanged(QString );
    void              PathButtonPressed();
    void              BookmarkButtonPressed();
    void              slotListViewGotFocus();
    void              slotListViewLostFocus();
    void              updateSelection();
    void              keyPressEvent(QKeyEvent *ke);
    void              keyReleaseEvent(QKeyEvent *ke);
    void              cursorRequested(QKeyEvent *);
    void              setDirFromBookmark(const QString &);
    void              changePropertiesForFile(QFileInfo);
    void              makeSymlinkToFile(QFileInfo);

public slots:
    void              setDir(QString dir);
    void              switchView(QString);
signals:
    void              pathButtonPressed();
    void              itemRequested();
    void              bookmarksChanged();
};

#endif // KCFILEDIALOG_H
