/***************************************************************************
                          statuslineentry.cpp  -  description
                             -------------------
    begin                : Fri Apr 19 2002
    copyright            : (C) 2002 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/


#include "statuslineentry.h"

statusLineEntry::statusLineEntry(QWidget *parent, const char *name ) : QWidget(parent,name)
{
  setBackgroundColor(red);
  lb = new QLabel(this);
  QFont *myFont = new QFont("fixed", 14,QFont::Bold);  // CONFIGURABLE !!
  // ohne diesem gibt pixelSize() -1 zurck
  myFont->setPixelSize(14);                             // Hier machst du die Ansicht breiter, probiere mal aus :)
  // feste Breite fr Font setzen
  myFont->setFixedPitch(1);
  setFont(*myFont);
}
statusLineEntry::~statusLineEntry(){
}
//void  statusLineEntry::paintEvent(QPaintEvent *e)
//{
//  QWidget::paintEvent(e);
//}
void  statusLineEntry::resizeEvent(QResizeEvent *e)
{
  lb->setGeometry(0,0,e->size().width(),e->size().height());
}
void  statusLineEntry::setText(const QString s)
{
  lb->setText(s);
}
